//+------------------------------------------------------------------+
//|                                                  MiddleZZAdv.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#include <stdlib.mqh>
//--- input parameters
extern string IndParam=" ";
extern int       ExtDepth=100;
extern int       ExtDeviation=0;
extern int       ExtBackstep=45;
extern string AdvParam=" ";
extern int       StopLoss=100;
extern int       TakeProfit=200;
extern double    FixLot=0.1;
extern double    MaxRisk=1.0;
extern int       Magic=1991;
extern int       Step=40;
extern int       Slippage=1;
extern int       MaxPendings=3;
extern int       PendingStep=20;
extern bool      AlertEnable=true;
extern bool      Trade=false;

bool Opn_BS,Opn_SS;int i,j;double ZZCur,ZZPrev,Price;int TotalPend,Buy,Sell; 
//+------------------------------------------------------------------+
int init(){Opn_BS=false;Opn_SS=false;Price=0;return(0);}
//+------------------------------------------------------------------+
int deinit(){Comment("");ObjectsDeleteAll();return(0);}
//+------------------------------------------------------------------+
int start()
{int Buy,Sell,TicketBuy,TicketSell;TotalPend=0;Buy=0;Sell=0;//  
  double SSL,STP,BSL,BTP;bool Ans;string PriceS;
// .  .  
  ZZCur=0;ZZPrev=0;i=0;j=0;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   ZIG-ZAG ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
// 
while(iCustom(NULL,0,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,i)==0) i++;
ZZCur=iCustom(NULL,0,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,i);
// 
j=i;
while((iCustom(NULL,0,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,j) == 0) || 
    (iCustom(NULL,0,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,j) == ZZCur)) j++;
ZZPrev=iCustom(NULL,0,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,j);

if(ZZCur<ZZPrev){Opn_BS=true;}if(ZZCur>ZZPrev){Opn_SS=true;}

//       
Price=(ZZCur+ZZPrev)/2; 
Price=(NormalizeDouble(Price,Digits));
/*
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   ZZ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
for(int cntord0=1; cntord0<=OrdersTotal(); cntord0++)          //   
     {
      if (OrderSelect(cntord0-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic )
         {      
          if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP)
            if (OrderOpenPrice() != Price) // ZZ  --  
             { 
              Ans=OrderDelete(OrderTicket(), Aqua);
              if (Ans==true) 
               Alert("ZZ !   !   ", OrderOpenPrice());
              if (Ans==false)
               Alert("    .   ", ErrorDescription(GetLastError()));
               }
          }
       }
      }
*/
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
for(int cntord=OrdersTotal()-1;cntord>=0;cntord--)          //   
   {if(OrderSelect(cntord,SELECT_BY_POS))//  
    {if(OrderSymbol()!=Symbol()||OrderMagicNumber()!= Magic)continue; //   . 
     if(OrderType()==OP_BUYSTOP||OrderType()==OP_SELLSTOP){TotalPend++;}
     if(OrderType()==OP_BUY){Buy++;}if(OrderType()==OP_SELL){Sell++;}
     if(TotalPend>0&&OrderType()==OP_SELLSTOP){Opn_SS=false;}
     if(TotalPend>0&&OrderType()==OP_BUYSTOP){Opn_BS=false;}
     if(TotalPend>1&&(Buy>1||Sell>1)){Opn_BS=false;Opn_SS=false;Alert(" ");Sleep(3000);
     return(0);}}}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//   Price -- BUYSTOP
RefreshRates();double ask=NormalizeDouble(Ask,Digits);
///if (Opn_BS){Alert("Opn_BS==true");}
//if (Price > ask){Alert("Price > ask");}
//if (ZZCur<ZZPrev ){Alert("ZZCur<ZZPrev ");}Sleep(3000);
if(Opn_BS&&Price>ask&&ZZCur<ZZPrev&&Trade)
 {//RefreshRates();
   
  BSL=NormalizeDouble(Price-New_Stop(StopLoss)*Point,Digits);
  BTP=NormalizeDouble(Price+New_Stop(TakeProfit)*Point,Digits);
 TicketBuy=OrderSend(
   Symbol(), //
   OP_BUYSTOP, //  
   FixLot, // 
   Price, //,  
   Slippage,0,0,
   //BSL, //
   //BTP, //  
   "MiddleZZAdv",Magic,0,Green);Sleep(3000);
   
  if(TicketBuy<0)Alert("   BUYSTOP   ",Price,
   "\n ", Symbol(), ",   ", ErrorDescription(GetLastError()) );
  if(TicketBuy>0)Alert(" BUYSTOP   ",Price,", ",Symbol());  
  }
 
//   Price -- SELLSTOP  
RefreshRates();double bid=NormalizeDouble(Bid,Digits);
if(Opn_SS&&Price<bid&&ZZCur>ZZPrev&&Trade)
 {SSL=NormalizeDouble(Price+New_Stop(StopLoss)*Point,Digits);
  STP=NormalizeDouble(Price-New_Stop(TakeProfit)*Point,Digits);
   TicketSell=OrderSend(
   Symbol(),   //
   OP_SELLSTOP,//  
   FixLot, //
   Price, //,  
   Slippage,//0,0,
   SSL, //
   STP, //  
   "MiddleZZAdv",Magic,0,OrangeRed);Sleep(3000);
   
   if(TicketSell<0)Alert("   SELLSTOP   ",Price,
   "\n ",Symbol(),",   ", ErrorDescription(GetLastError()));
   if(TicketSell>0)Alert(" SELLSTOP   ",Price,", ",Symbol());  
  }  
Comment("",
  "\n ZZCur= ",ZZCur,
  "\n ZZPrev= ",ZZPrev,
  "\n Difference= ",MathAbs(ZZCur-ZZPrev), 
  "\n Price= ",Price,
 "\n TotalPend= ", TotalPend,
  "\n Buy = ",Buy,
  "\n Sell= ",Sell,
  "\n Spread= ",MarketInfo(Symbol(),MODE_SPREAD));return(0);}

// ----------------------------   - ----------------------------------
int New_Stop(int Parametr)                          // -.
 {int Min_Dist=MarketInfo(Symbol(),MODE_STOPLEVEL);//. 
   if(Parametr<Min_Dist)                            //   .
   {Parametr=Min_Dist+1;                            // .
      Alert("  -.");}
   return(Parametr); }                               // 
  